package eu.mhsl.craftattack.spawn.common.api;

import eu.mhsl.craftattack.spawn.core.config.Configuration;
import org.apache.http.client.utils.URIBuilder;
import org.bukkit.configuration.ConfigurationSection;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.Objects;

public class CraftAttackApi {
    private final static ConfigurationSection apiConfig = Objects.requireNonNull(Configuration.cfg.getConfigurationSection("api"));
    public final static String basePath = apiConfig.getString("baseurl");
    public final static String apiSecret = apiConfig.getString("secret");

    public static URI getBaseUri() {
        Objects.requireNonNull(basePath);
        try {
            return new URI(basePath);
        } catch(URISyntaxException e) {
            throw new RuntimeException(e);
        }
    }

    public static void withAuthorizationSecret(URIBuilder builder) {
        builder.addParameter("secret", apiSecret);
    }
}
