package eu.mhsl.craftattack.spawn.common.api;

import eu.mhsl.craftattack.spawn.core.config.Configuration;
import org.bukkit.configuration.ConfigurationSection;

import java.net.URI;
import java.net.URISyntaxException;
import java.net.http.HttpRequest;
import java.util.Objects;

public class VaroApi {
    private final static ConfigurationSection apiConfig = Objects.requireNonNull(Configuration.cfg.getConfigurationSection("varoApi"));
    public final static String basePath = apiConfig.getString("endpoint");
    public final static String apiSecret = apiConfig.getString("auth");

    public static URI getBaseUri() {
        Objects.requireNonNull(basePath);
        try {
            return new URI(basePath);
        } catch(URISyntaxException e) {
            throw new RuntimeException(e);
        }
    }

    public static void authorizationHeader(HttpRequest.Builder builder) {
        builder.header("Authorization", apiSecret);
    }
}