package eu.mhsl.craftattack.spawn.common.api.repositories;

import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.common.api.CraftAttackApi;
import java.util.UUID;

public class CraftAttackReportRepository extends ReportRepository {
    public CraftAttackReportRepository() {
        super(CraftAttackApi.getBaseUri(), new RequestModifier(CraftAttackApi::withAuthorizationSecret, null));
    }

    public ReqResp<PlayerReports> queryReports(UUID player) {
        return this.get(
            "report",
            (parameters) -> parameters.addParameter("uuid", player.toString()),
            PlayerReports.class
        );
    }

    public ReqResp<ReportUrl> createReport(ReportCreationInfo data) {
        return this.post(
            "report",
            data,
            ReportUrl.class
        );
    }
}
