package eu.mhsl.craftattack.spawn.common.api.repositories;

import eu.mhsl.craftattack.spawn.core.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.core.api.client.RepositoryLoader;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.net.URI;
import java.util.List;
import java.util.UUID;

@RepositoryLoader.Abstraction
public abstract class ReportRepository extends HttpRepository {
    public ReportRepository(URI basePath, RequestModifier... baseRequestModifier) {
        super(basePath, baseRequestModifier);
    }

    public record ReportCreationInfo(@NotNull UUID reporter, @Nullable UUID reported, String reason) {
    }

    public record ReportUrl(@NotNull String url) {
    }

    public record PlayerReports(
        List<Report> from_self,
        Object to_self
    ) {
        public record Report(
            @Nullable Reporter reported,
            @NotNull String subject,
            boolean draft,
            @NotNull String status,
            @NotNull String url
        ) {
            public record Reporter(
                @NotNull String username,
                @NotNull String uuid
            ) {
            }
        }
    }
}
