package eu.mhsl.craftattack.spawn.common.api.repositories;

import eu.mhsl.craftattack.spawn.common.api.VaroApi;
import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import org.apache.commons.lang3.NotImplementedException;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.UUID;

public class VaroReportRepository extends ReportRepository {
    public VaroReportRepository() {
        super(VaroApi.getBaseUri(), new RequestModifier(null, VaroApi::authorizationHeader));
    }

    public ReqResp<PlayerReports> queryReports(UUID player) {
        throw new NotImplementedException("Report querying is not supported in Varo!");
    }

    public ReqResp<ReportUrl> createReport(ReportCreationInfo data) {
        return this.post(
            "report",
            data,
            ReportUrl.class
        );
    }

    public record StrikeCreationInfo(
        @Nullable UUID reporter, // null for automatic creations
        @NotNull UUID reported,
        @NotNull String reason,
        @Nullable String body,
        @Nullable String notice,
        @Nullable String statement,
        int strike_reason_id // internal strike mapping
    ) {
    }
    public ReqResp<Void> createStrike(StrikeCreationInfo data) {
        return this.put(
            "report",
            data,
            Void.class
        );
    }
}
