package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.adminMarker;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.api.server.HttpServer;
import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.displayName.DisplayName;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Bukkit;
import org.bukkit.Color;
import org.bukkit.OfflinePlayer;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.Nullable;

import java.util.UUID;

public class AdminMarker extends Appliance implements DisplayName.Colored {
    public final static String adminPermission = "admin";

    @Override
    public @Nullable TextColor getNameColor(Player player) {
        if(player.hasPermission(adminPermission))
            return TextColor.color(Color.AQUA.asRGB()); // TODO read permission from config
        return TextColor.color(Color.WHITE.asRGB());
    }

    @Override
    public void httpApi(HttpServer.ApiBuilder apiBuilder) {
        apiBuilder.get("isAdmin", request -> {
            OfflinePlayer player = Bukkit.getOfflinePlayer(UUID.fromString(request.queryParams("player")));
            Main.logger().info(String.format("Adminstatus requested for %s, response: %s", player.getUniqueId(), player.isOp()));
            return player.isOp();
        });
    }
}
