package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.chatMention;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import net.kyori.adventure.sound.Sound;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.Arrays;
import java.util.List;
import java.util.Objects;

public class ChatMention extends Appliance {
    private static List<String> playerNames;

    public String formatPlayer(String name) {
        return "@" + name;
    }

    public List<String> getPlayerNames() {
        return playerNames;
    }

    public void refreshPlayers() {
        Bukkit.getScheduler().runTaskAsynchronously(
            Main.instance(),
            () -> playerNames = Arrays.stream(Bukkit.getOfflinePlayers())
                .map(OfflinePlayer::getName)
                .filter(Objects::nonNull)
                .toList()
        );
    }

    public void notifyPlayers(List<String> playerNames) {
        playerNames.stream()
            .distinct()
            .map(Bukkit::getPlayer)
            .filter(Objects::nonNull)
            .filter(player -> Settings.instance()
                .getSetting(player, Settings.Key.ChatMentions, ChatMentionSetting.ChatMentionConfig.class)
                .notifyOnMention()
            )
            .forEach(player -> player.playSound(
                Sound.sound(
                    org.bukkit.Sound.ENTITY_EXPERIENCE_ORB_PICKUP,
                    Sound.Source.PLAYER,
                    1.0f,
                    1.0f
                )
            ));
    }

    @Override
    public void onEnable() {
        Settings.instance().declareSetting(ChatMentionSetting.class);
        this.refreshPlayers();
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new ChatMentionListener());
    }
}
