package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.chatMention;

import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.CategorizedSetting;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.SettingCategory;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.datatypes.MultiBoolSetting;
import org.bukkit.Material;

public class ChatMentionSetting extends MultiBoolSetting<ChatMentionSetting.ChatMentionConfig> implements CategorizedSetting {
    @Override
    public SettingCategory category() {
        return SettingCategory.Visuals;
    }

    public record ChatMentionConfig(
        @DisplayName("Spielernamen hervorheben") boolean applyMentions,
        @DisplayName("Benachrichtigungston") boolean notifyOnMention
    ) {
    }

    public ChatMentionSetting() {
        super(Settings.Key.ChatMentions);
    }

    @Override
    protected String title() {
        return "Erwähnungen im Chat";
    }

    @Override
    protected String description() {
        return "Erwähnungen werden automatisch im Chat angewandt und der Empfänger erhält einen Signalton";
    }

    @Override
    protected Material icon() {
        return Material.FEATHER;
    }

    @Override
    protected ChatMentionConfig defaultValue() {
        return new ChatMentionConfig(true, true);
    }

    @Override
    public Class<?> dataType() {
        return ChatMentionConfig.class;
    }
}
