package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.chatMessages;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.ClickEvent;
import net.kyori.adventure.text.event.HoverEvent;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class ChatMessages extends Appliance {
    @Override
    public void onEnable() {
        Settings.instance().declareSetting(ShowJoinAndLeaveMessagesSetting.class);
    }

    public Component getReportablePlayerName(Player player) {
        return this.addReportActions(player.displayName(), player.getName());
    }

    public Component addReportActions(Component message, String username) {
        return message
            .hoverEvent(HoverEvent.showText(Component.text("Klicke, um diesen Spieler zu reporten").color(NamedTextColor.GOLD)))
            .clickEvent(ClickEvent.clickEvent(ClickEvent.Action.SUGGEST_COMMAND, String.format("/report %s ", username)));
    }

    @Override
    @NotNull
    protected List<Listener> listeners() {
        return List.of(new ChatMessagesListener());
    }
}
