package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.chatMessages;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import eu.mhsl.craftattack.spawn.core.util.IteratorUtil;
import io.papermc.paper.event.player.AsyncChatEvent;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Color;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;

import java.util.Optional;

class ChatMessagesListener extends ApplianceListener<ChatMessages> {
    @EventHandler
    public void onPlayerChatEvent(AsyncChatEvent event) {
        event.renderer(
            (source, sourceDisplayName, message, viewer) ->
                Component.text("")
                    .append(this.getAppliance().getReportablePlayerName(source))
                    .append(Component.text(" > ").color(TextColor.color(Color.GRAY.asRGB())))
                    .append(message).color(TextColor.color(Color.SILVER.asRGB()))
        );
    }

    @EventHandler(priority = EventPriority.HIGH)
    public void onPlayerJoin(PlayerJoinEvent event) {
        boolean wasHidden = event.joinMessage() == null;
        event.joinMessage(null);
        if(wasHidden) return;
        IteratorUtil.onlinePlayers(player -> {
            if(!Settings.instance().getSetting(player, Settings.Key.ShowJoinAndLeaveMessages, Boolean.class)) return;
            player.sendMessage(
                Component
                    .text(">>> ").color(NamedTextColor.GREEN)
                    .append(this.getAppliance().getReportablePlayerName(event.getPlayer()))
            );
        });
    }

    @EventHandler
    public void onPlayerLeave(PlayerQuitEvent event) {
        boolean wasHidden = event.quitMessage() == null;
        event.quitMessage(null);
        if(wasHidden) return;
        IteratorUtil.onlinePlayers(player -> {
            if(!Settings.instance().getSetting(player, Settings.Key.ShowJoinAndLeaveMessages, Boolean.class)) return;
            player.sendMessage(
                Component
                    .text("<<< ").color(NamedTextColor.RED)
                    .append(this.getAppliance().getReportablePlayerName(event.getPlayer()))
            );
        });
    }

    @EventHandler
    public void onDeath(PlayerDeathEvent event) {
        event.deathMessage(
            Component
                .text("☠ ")
                .append(
                    Optional
                        .ofNullable(event.deathMessage())
                        .orElse(Component.text(event.getPlayer().getName()))
                )
                .color(TextColor.color(Color.SILVER.asRGB()))
        );
    }
}
