package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.infoBars;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

class InfoBarCommand extends ApplianceCommand.PlayerChecked<InfoBars> {
    public InfoBarCommand() {
        super("infobar");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length == 0) throw new Error("<show|hide|hideall> [bar name]");
        switch(args[0]) {
            case "hideAll" -> this.getAppliance().hideAll(this.getPlayer());
            case "show" -> this.getAppliance().show(this.getPlayer(), args[1]);
            case "hide" -> this.getAppliance().hide(this.getPlayer(), args[1]);
            default -> throw new Error("Erlaubte Optionen sind 'show', 'hide', 'hideAll'!");
        }
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(args.length == 1) return List.of("show", "hide", "hideAll");
        return this.getAppliance().getInfoBars().stream().map(Bar::name).toList();
    }
}
