package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.infoBars.bars;

import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.infoBars.Bar;
import eu.mhsl.craftattack.spawn.core.util.statistics.ServerMonitor;
import eu.mhsl.craftattack.spawn.core.util.text.ColorUtil;
import net.kyori.adventure.bossbar.BossBar;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;

import java.time.Duration;

public class MsptBar extends Bar {
    @Override
    protected Duration refresh() {
        return Duration.ofSeconds(3);
    }

    @Override
    protected String name() {
        return "mspt";
    }

    @Override
    protected Component title() {
        return Component.text()
            .append(Component.text("M"))
            .append(Component.text("illi", NamedTextColor.GRAY))
            .append(Component.text("S"))
            .append(Component.text("econds ", NamedTextColor.GRAY))
            .append(Component.text("P"))
            .append(Component.text("er ", NamedTextColor.GRAY))
            .append(Component.text("T"))
            .append(Component.text("ick", NamedTextColor.GRAY))
            .append(Component.text(": "))
            .append(Component.text(String.format("%.2f", this.currentMSPT()), ColorUtil.msptColor(this.currentMSPT())))
            .build();
    }

    @Override
    protected float progress() {
        return this.currentMSPT() / 50f;
    }

    @Override
    protected BossBar.Color color() {
        return BossBar.Color.BLUE;
    }

    @Override
    protected BossBar.Overlay overlay() {
        return BossBar.Overlay.PROGRESS;
    }

    private float currentMSPT() {
        return ServerMonitor.getServerMSPT();
    }
}
