package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.infoBars.bars;

import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.infoBars.Bar;
import eu.mhsl.craftattack.spawn.core.util.text.ColorUtil;
import net.kyori.adventure.bossbar.BossBar;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;

import java.time.Duration;

public class TpsBar extends Bar {
    @Override
    protected Duration refresh() {
        return Duration.ofSeconds(3);
    }

    @Override
    protected String name() {
        return "tps";
    }

    @Override
    protected Component title() {
        return Component.text()
            .append(Component.text("T"))
            .append(Component.text("icks ", NamedTextColor.GRAY))
            .append(Component.text("P"))
            .append(Component.text("er ", NamedTextColor.GRAY))
            .append(Component.text("S"))
            .append(Component.text("econds", NamedTextColor.GRAY))
            .append(Component.text(": "))
            .append(Component.text(String.format("%.2f", this.currentTps()), ColorUtil.tpsColor(this.currentTps())))
            .build();
    }

    @Override
    protected float progress() {
        return this.currentTps() / 20;
    }

    @Override
    protected BossBar.Color color() {
        return BossBar.Color.BLUE;
    }

    @Override
    protected BossBar.Overlay overlay() {
        return BossBar.Overlay.NOTCHED_20;
    }

    private float currentTps() {
        return (float) Bukkit.getTPS()[0];
    }
}
