package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.report;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.core.util.text.ComponentUtil;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

class ReportCommand extends ApplianceCommand.PlayerChecked<Report> {
    public ReportCommand() {
        super("report");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        sender.sendMessage(ComponentUtil.pleaseWait());

        if(args.length == 0) {
            this.getAppliance().reportToUnknown(this.getPlayer());
        }

        if(args.length == 1) {
            this.getAppliance().reportToKnown(this.getPlayer(), args[0], null);
        }

        if(args.length > 1) {
            this.getAppliance().reportToKnown(this.getPlayer(), args[0], Arrays.stream(args).skip(1).collect(Collectors.joining(" ")));
        }
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        List<String> response = new ArrayList<>();

        if(args.length == 1) {
            response = Stream.concat(
                Bukkit.getOnlinePlayers().stream().map(Player::getName),
                Arrays.stream(Bukkit.getOfflinePlayers()).map(OfflinePlayer::getName)
            ).toList();
        }

        if(args.length == 2) {
            response = List.of(
                "Griefing",
                "Diebstahl",
                "Beleidigung",
                "Hacking",
                "Andere Regelverstöße",
                " "
            );
        }

        return super.tabCompleteReducer(response, args);
    }
}
