package eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.datatypes;

import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public abstract class BoolSetting extends Setting<Boolean> {
    public BoolSetting(Settings.Key key) {
        super(key);
    }

    @Override
    public void fromStorage(PersistentDataContainer container) {
        this.state = container.has(this.getNamespacedKey())
            ? Objects.requireNonNull(container.get(this.getNamespacedKey(), PersistentDataType.BOOLEAN))
            : this.defaultValue();
    }

    @Override
    protected void toStorage(PersistentDataContainer container, Boolean value) {
        container.set(this.getNamespacedKey(), PersistentDataType.BOOLEAN, value);
    }

    @Override
    public ItemMeta buildMeta(ItemMeta meta) {
        meta.displayName(Component.text(this.title(), NamedTextColor.WHITE));
        List<Component> lore = new ArrayList<>(List.of(
            Component.empty()
                .append(Component.text("Status: ", NamedTextColor.DARK_GRAY))
                .append(Component.text(
                    this.state ? "Aktiviert" : "Deaktiviert",
                    this.state ? NamedTextColor.GREEN : NamedTextColor.RED)
                ),
            Component.empty()
        ));
        lore.addAll(this.buildDescription(this.description()));
        meta.lore(lore);
        return meta;
    }

    @Override
    protected void change(Player player, ClickType clickType) {
        this.state = !this.state;
    }

    @Override
    public Class<?> dataType() {
        return Boolean.class;
    }

    @Override
    public Boolean state() {
        return this.state;
    }
}
