package eu.mhsl.craftattack.spawn.common.appliances.tooling.acInform;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.ComponentBuilder;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.event.ClickEvent;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

public class AcInform extends Appliance {
    public void processCommand(@NotNull String[] args) {
        String anticheatName = null;
        String playerName = null;
        String checkName = null;
        Float violationCount = null;

        for(int i = 0; i < args.length; i++) {
            if(!args[i].startsWith("--")) continue;

            StringBuilder valueBuilder = new StringBuilder();
            for(int j = i + 1; j < args.length; j++) {
                if(args[j].startsWith("--")) break;
                if(!valueBuilder.isEmpty()) valueBuilder.append(" ");
                valueBuilder.append(args[j]);
            }

            String value = valueBuilder.toString();
            switch(args[i]) {
                case "--anticheatName" -> anticheatName = value;
                case "--playerName" -> playerName = value;
                case "--check" -> checkName = value;
                case "--violationCount" -> violationCount = value.isEmpty() ? null : Float.valueOf(value);
            }
        }

        this.notifyAdmins(anticheatName, playerName, checkName, violationCount);
    }

    public void notifyAdmins(@Nullable String anticheatName, @Nullable String playerName, @Nullable String checkName, @Nullable Float violationCount) {
        ComponentBuilder<TextComponent, TextComponent.Builder> component = Component.text();
        NamedTextColor textColor = NamedTextColor.GRAY;

        if(playerName == null || playerName.isBlank())
            throw new ApplianceCommand.Error("acinform command needs a player (--playerName)");

        if(anticheatName != null && !anticheatName.isBlank()) {
            component
                .append(Component.text("⊤ ", NamedTextColor.GRAY))
                .append(Component.text("[", textColor))
                .append(Component.text(anticheatName, NamedTextColor.RED))
                .append(Component.text("]: ", textColor));
        }

        component
            .append(Component.text("Player ", textColor))
            .append(Component.text(playerName, NamedTextColor.WHITE))
            .append(Component.text(" "));

        if(checkName == null || checkName.isBlank()) {
            component.append(Component.text("got detected by Anticheat", textColor));
        } else if(violationCount != null) {
            component.append(
                Component.text("failed ", textColor)
                    .append(Component.text(String.format("%sx ", violationCount), NamedTextColor.WHITE))
                    .append(Component.text("'", textColor))
                    .append(Component.text(checkName, NamedTextColor.WHITE))
                    .append(Component.text("'", textColor))
            );
        } else {
            component.append(
                Component.text("failed ", textColor)
                    .append(Component.text("'", textColor))
                    .append(Component.text(checkName, NamedTextColor.WHITE))
                    .append(Component.text("'", textColor))
            );
        }

        component.append(
            Component.newline()
                .append(Component.text("⊥ ", NamedTextColor.GRAY))
                .append(Component.text("[", NamedTextColor.GRAY))
                .append(Component.text("Report", NamedTextColor.GOLD))
                .append(Component.text("]", NamedTextColor.GRAY))
                .clickEvent(ClickEvent.suggestCommand(String.format("/report %s anticheat %s flagged %s", playerName, anticheatName, checkName)))
        );

        component.append(
            Component.text(" [", NamedTextColor.GRAY)
                .append(Component.text("Kick", NamedTextColor.GOLD))
                .append(Component.text("]", NamedTextColor.GRAY))
                .clickEvent(ClickEvent.suggestCommand(String.format("/kick %s", playerName)))
        );

        component.append(
            Component.text(" [", NamedTextColor.GRAY)
                .append(Component.text("Panic Ban", NamedTextColor.GOLD))
                .append(Component.text("]", NamedTextColor.GRAY))
                .clickEvent(ClickEvent.suggestCommand(String.format("/panicban %s", playerName)))
        );

        component.append(
            Component.text(" [", NamedTextColor.GRAY)
                .append(Component.text("Spectate/Teleport", NamedTextColor.GOLD))
                .append(Component.text("]", NamedTextColor.GRAY))
                .clickEvent(ClickEvent.suggestCommand(String.format("/grim spectate %s", playerName)))
        );

        TextComponent finalMessage = component.build();

        Bukkit.getOnlinePlayers().stream()
            .filter(player -> player.hasPermission("admin"))
            .forEach(player -> player.sendMessage(finalMessage));

    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(
            new AcInformCommand()
        );
    }
}
