package eu.mhsl.craftattack.spawn.common.appliances.tooling.chatMute;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Locale;
import java.util.Objects;

public class ChatMute extends Appliance {
    private static final String namespace = ChatMute.class.getSimpleName().toLowerCase(Locale.ROOT);
    public static NamespacedKey mutedUntilKey = new NamespacedKey(namespace, "mutedUntilMillis".toLowerCase());

    public void mutePlayer(Player player, int durationHours) {
        PersistentDataContainer container = player.getPersistentDataContainer();
        long mutedUntil = System.currentTimeMillis() + (long) durationHours * 60 * 60 * 1000;
        container.set(ChatMute.mutedUntilKey, PersistentDataType.LONG, mutedUntil);
    }

    public @Nullable Long muteStatus(Player player) {
        PersistentDataContainer container = player.getPersistentDataContainer();
        if(!container.has(mutedUntilKey)) return null;
        long mutedUntil = Objects.requireNonNull(container.get(mutedUntilKey, PersistentDataType.LONG));
        if(mutedUntil < System.currentTimeMillis()) return null;
        return mutedUntil;
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new MuteCommand());
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new ChatMuteListener());
    }
}
