package eu.mhsl.craftattack.spawn.common.appliances.tooling.chatMute;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Objects;

class MuteCommand extends ApplianceCommand<ChatMute> {
    public MuteCommand() {
        super("mute");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length < 2) throw new Error("Syntax: mute <player> <duration in hours>");
        Player player = Objects.requireNonNull(Bukkit.getPlayer(args[0]));
        int durationInHours = Integer.parseInt(args[1]);
        this.getAppliance().mutePlayer(player, durationInHours);
        sender.sendMessage(String.format("%s wurde für %d Stunden gestummt!", player.getName(), durationInHours));
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(args.length == 2) {
            return List.of("1", "2", "4", "8", "24", "48");
        }
        return null;
    }
}
