package eu.mhsl.craftattack.spawn.common.appliances.tooling.endPrevent;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Map;

class EndPreventCommand extends ApplianceCommand<EndPrevent> {
    private final Map<String, EndPrevent.State> arguments = Map.of(
        "preventEnd", EndPrevent.State.CLOSED,
        "allowEnd", EndPrevent.State.OPEN,
        "onlyInnerEnd", EndPrevent.State.NO_OUTER
    );

    public EndPreventCommand() {
        super("endPrevent");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length == 1 && this.arguments.containsKey(args[0])) {
            this.getAppliance().setEndState(this.arguments.get(args[0]));
            sender.sendMessage(Component.text("Setting updated!", NamedTextColor.GREEN));
        }
        sender.sendMessage(Component.text(
            String.format("The End is now on '%s'!", this.getAppliance().getEndPreventState().name()),
            NamedTextColor.GOLD
        ));
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        return this.arguments.keySet().stream().toList();
    }
}
