package eu.mhsl.craftattack.spawn.common.appliances.tooling.endPrevent;

import com.destroystokyo.paper.event.player.PlayerTeleportEndGatewayEvent;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerPortalEvent;

class EndPreventListener extends ApplianceListener<EndPrevent> {
    @EventHandler
    public void onEnderEyeInteraction(PlayerInteractEvent event) {
        if(event.getClickedBlock() == null) return;
        if(!event.getClickedBlock().getType().equals(Material.END_PORTAL_FRAME)) return;
        if(event.getItem() == null) return;
        if(!event.getItem().getType().equals(Material.ENDER_EYE)) return;

        this.cancelIfClosed(event, event.getPlayer());
    }

    @EventHandler
    public void onPlayerPortal(PlayerPortalEvent event) {
        if(!event.getTo().getWorld().getEnvironment().equals(World.Environment.THE_END)) return;

        this.cancelIfClosed(event, event.getPlayer());
    }

    @EventHandler
    public void onPlayerEndGateway(PlayerTeleportEndGatewayEvent event) {
        this.cancelIfOnlyInner(event, event.getPlayer());
    }

    private void cancelIfClosed(Cancellable event, Player p) {
        if(!this.getAppliance().isEndClosed()) return;
        event.setCancelled(true);
        p.sendActionBar(Component.text("Das End ist nicht freigeschaltet!", NamedTextColor.RED));
    }

    private void cancelIfOnlyInner(Cancellable event, Player p) {
        if(!this.getAppliance().isOnlyInner()) return;
        event.setCancelled(true);
        p.sendActionBar(Component.text("Das Outer End ist nicht freigeschaltet!", NamedTextColor.RED));
    }
}
