package eu.mhsl.craftattack.spawn.common.appliances.tooling.maintenance;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.core.config.Configuration;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class Maintenance extends Appliance {
    private boolean isInMaintenance;
    private final String configKey = "enabled";

    public Maintenance() {
        super("maintenance");
    }

    @Override
    public void onEnable() {
        this.isInMaintenance = this.localConfig().getBoolean(this.configKey, false);
    }

    public void setState(boolean enabled) {
        this.isInMaintenance = enabled;
        this.localConfig().set(this.configKey, enabled);
        Configuration.saveChanges();
    }

    public boolean isInMaintenance() {
        return this.isInMaintenance;
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new MaintenanceCommand());
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new PreventMaintenanceJoinListener());
    }
}
