package eu.mhsl.craftattack.spawn.common.appliances.tooling.maintenance;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Map;

class MaintenanceCommand extends ApplianceCommand<Maintenance> {
    private final Map<String, Boolean> arguments = Map.of("enable", true, "disable", false);

    public MaintenanceCommand() {
        super("maintanance");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length == 1 && this.arguments.containsKey(args[0])) {
            this.getAppliance().setState(this.arguments.get(args[0]));
            sender.sendMessage(Component.text("Maintanance mode updated!", NamedTextColor.GREEN));
        }
        sender.sendMessage(Component.text(
            String.format("Maintanance mode is %b", this.getAppliance().isInMaintenance()),
            NamedTextColor.GOLD
        ));
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        return this.arguments.keySet().stream().toList();
    }
}
