package eu.mhsl.craftattack.spawn.common.appliances.tooling.playerlimit;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.core.config.Configuration;
import org.bukkit.Bukkit;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class PlayerLimit extends Appliance {
    private static final String playerLimitKey = "maxPlayers";
    private int limit;

    public PlayerLimit() {
        super("playerLimit");
        this.limit = this.localConfig().getInt(playerLimitKey);
        Bukkit.setMaxPlayers(Integer.MAX_VALUE);
    }

    public void setPlayerLimit(int limit) {
        this.limit = limit;
        this.localConfig().set(playerLimitKey, limit);
        Configuration.saveChanges();
    }

    public int getLimit() {
        return this.limit;
    }

    @Override
    @NotNull
    protected List<Listener> listeners() {
        return List.of(
            new PlayerLimiterListener()
        );
    }

    @Override
    @NotNull
    protected List<ApplianceCommand<?>> commands() {
        return List.of(
            new SetPlayerLimitCommand()
        );
    }
}
