package eu.mhsl.craftattack.spawn.core.api.client;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import eu.mhsl.craftattack.spawn.core.Main;
import org.bukkit.Bukkit;

import java.net.URI;

public abstract class Repository {
    protected URI basePath;
    protected Gson gson;

    public Repository(URI basePath) {
        this.basePath = basePath;
        this.gson = new GsonBuilder()
            .serializeNulls()
            .create();
    }

    protected void validateThread(String commandName) {
        if(!Bukkit.isPrimaryThread()) return;

        Main.logger().warning(String.format(
            "Repository '%s' was called synchronously with command '%s'!",
            this.getClass().getSimpleName(),
            commandName
        ));
    }
}
