package eu.mhsl.craftattack.spawn.core.config;

import eu.mhsl.craftattack.spawn.core.Main;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class Configuration {
    private static final String configName = "config.yml";
    private static final File configFile = new File(Main.instance().getDataFolder().getAbsolutePath() + "/" + configName);
    public static FileConfiguration cfg;
    public static ConfigurationSection pluginConfig;

    public static void readConfig() {
        cfg = YamlConfiguration.loadConfiguration(configFile);
        pluginConfig = cfg.getConfigurationSection("plugin");
    }

    public static void saveChanges() {
        try {
            cfg.save(configFile);
        } catch(Exception e) {
            Main.logger().warning("Could not save configuration: " + e.getMessage());
        }
    }

}
