package eu.mhsl.craftattack.spawn.core.util.listener;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractAtEntityEvent;

import java.util.UUID;
import java.util.function.Consumer;

public class PlayerInteractAtEntityEventListener implements Listener {
    private final UUID interactableEntityUUID;
    private final Consumer<PlayerInteractAtEntityEvent> callback;

    public PlayerInteractAtEntityEventListener(UUID interactableEntityUUID, Consumer<PlayerInteractAtEntityEvent> callback) {
        this.interactableEntityUUID = interactableEntityUUID;
        this.callback = callback;
    }

    @EventHandler
    public void onInteract(PlayerInteractAtEntityEvent event) {
        if(!event.getRightClicked().getUniqueId().equals(this.interactableEntityUUID)) return;
        this.callback.accept(event);
    }
}
