package eu.mhsl.craftattack.spawn.core.util.server;

import org.bukkit.entity.Player;
import org.geysermc.cumulus.form.SimpleForm;
import org.geysermc.floodgate.api.FloodgateApi;
import org.geysermc.floodgate.api.player.FloodgatePlayer;

import java.util.function.Consumer;

public class Floodgate {
    private static final FloodgateApi instance = FloodgateApi.getInstance();

    public static boolean isBedrock(Player p) {
        return instance.isFloodgatePlayer(p.getUniqueId());
    }

    public static FloodgatePlayer getBedrockPlayer(Player p) {
        return instance.getPlayer(p.getUniqueId());
    }

    public static void runBedrockOnly(Player p, Consumer<FloodgatePlayer> callback) {
        if(isBedrock(p)) callback.accept(instance.getPlayer(p.getUniqueId()));
    }

    public static void runJavaOnly(Player p, Consumer<Player> callback) {
        if(!isBedrock(p)) callback.accept(p);
    }

    public static void throwWithMessageWhenBedrock(Player player) {
        if(isBedrock(player)) {
            SimpleForm.builder()
                .title("Nicht unterstützt")
                .content("Bedrock-Spieler werden derzeit für diese Aktion unterstützt! Tut uns Leid.")
                .button("Ok")
                .build();

            throw new BedrockNotSupportedException(player);
        }
    }

    public static class BedrockNotSupportedException extends RuntimeException {
        public BedrockNotSupportedException(Player player) {
            super(String.format("Bedrock player '%s' tried using an Operation which is unsupported.", player.getName()));
        }
    }
}
