package eu.mhsl.craftattack.spawn.core.util.text;

public class DataSizeConverter {
    public static String convertBytesPerSecond(long bytes) {
        double kbits = bytes * 8.0 / 1000.0;
        double mbits = kbits / 1000.0;

        if(mbits >= 1) {
            return String.format("%.2f Mbit", mbits);
        } else {
            return String.format("%.2f Kbit", kbits);
        }
    }

    public static String formatBytesToHumanReadable(long bytes) {
        String[] units = {"B", "KB", "MB", "GB", "TB", "PB", "EB"};
        int unitIndex = 0;
        double readableSize = bytes;

        while(readableSize >= 1024 && unitIndex < units.length - 1) {
            readableSize /= 1024;
            unitIndex++;
        }

        return String.format("%.2f%s", readableSize, units[unitIndex]);
    }

    public static String formatCpuTimeToHumanReadable(long nanoseconds) {
        if(nanoseconds < 0) return "unsupported";

        long seconds = nanoseconds / 1_000_000_000;
        long minutes = seconds / 60;
        long hours = minutes / 60;
        long days = hours / 24;

        seconds %= 60;
        minutes %= 60;
        hours %= 24;
        return String.format("%dd%dh%dm%ds", days, hours, minutes, seconds);
    }

    public static String formatSecondsToHumanReadable(int seconds) {
        if(seconds < 0) return "unsupported";

        int minutes = seconds / 60;
        int hours = minutes / 60;
        int days = hours / 24;

        seconds %= 60;
        minutes %= 60;
        hours %= 24;

        return String.format("%dd %dh %dm %ds", days, hours, minutes, seconds);
    }
}