package eu.mhsl.craftattack.spawn.craftattack.api.repositories;

import eu.mhsl.craftattack.spawn.core.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.craftattack.api.EventServerApi;

import java.util.UUID;

public class EventRepository extends HttpRepository {
    public EventRepository() {
        super(EventServerApi.getBaseUri());
    }

    public record CreatedRoom(UUID uuid) {
    }

    public record QueueRoom(UUID player, UUID room) {
        public record Response(String error) {
        }
    }

    public ReqResp<CreatedRoom> createSession() {
        return this.post("room", null, CreatedRoom.class);
    }

    public ReqResp<QueueRoom.Response> queueRoom(QueueRoom request) {
        return this.post("queueRoom", request, QueueRoom.Response.class);
    }
}
