package eu.mhsl.craftattack.spawn.craftattack.api.repositories;

import com.google.common.reflect.TypeToken;
import eu.mhsl.craftattack.spawn.core.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.common.api.CraftAttackApi;

import java.lang.reflect.Type;
import java.util.List;
import java.util.Map;
import java.util.UUID;

public class FeedbackRepository extends HttpRepository {
    public FeedbackRepository() {
        super(CraftAttackApi.getBaseUri(), new RequestModifier(CraftAttackApi::withAuthorizationSecret, null));
    }

    public record Request(String event, List<UUID> users) {
    }

    public ReqResp<Map<UUID, String>> createFeedbackUrls(Request data) {
        final Type responseType = new TypeToken<Map<UUID, String>>() {
        }.getType();
        ReqResp<Object> rawData = this.post("feedback", data, Object.class);
        // TODO: use convertToTypeToken from ReqResp
        return new ReqResp<>(rawData.status(), this.gson.fromJson(this.gson.toJson(rawData.data()), responseType));
    }
}
