package eu.mhsl.craftattack.spawn.craftattack.api.repositories;

import eu.mhsl.craftattack.spawn.core.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.common.api.CraftAttackApi;

import java.util.UUID;

public class WhitelistRepository extends HttpRepository {
    public WhitelistRepository() {
        super(CraftAttackApi.getBaseUri(), new RequestModifier(CraftAttackApi::withAuthorizationSecret, null));
    }

    public record UserData(
        UUID uuid,
        String username,
        String firstname,
        String lastname,
        Long banned_until,
        Long outlawed_until
    ) {
    }

    public ReqResp<UserData> getUserData(UUID userId) {
        return this.get(
            "user",
            parameters -> parameters.addParameter("uuid", userId.toString()),
            UserData.class
        );
    }
}
