package eu.mhsl.craftattack.spawn.craftattack.appliances.gameplay.antiSignEdit;

import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.CategorizedSetting;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.SettingCategory;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.datatypes.SelectSetting;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;

import java.util.List;
import java.util.Locale;

public class SignEditSetting extends SelectSetting implements CategorizedSetting {
    private static final String namespace = SignEditSetting.class.getSimpleName().toLowerCase(Locale.ROOT);
    public static Options.Option editable = new Options.Option("Bearbeitbar", new NamespacedKey(namespace, "editable"));
    public static Options.Option editableWhenEmpty = new Options.Option("Bearbeitbar wenn leer", new NamespacedKey(namespace, "emptyeditable"));
    public static Options.Option readOnly = new Options.Option("Nicht bearbeitbar", new NamespacedKey(namespace, "readonly"));

    public SignEditSetting() {
        super(
            Settings.Key.SignEdit,
            new Options(List.of(editable, editableWhenEmpty, readOnly))
        );
    }

    @Override
    protected String title() {
        return "Bearbeiten von Schildern";
    }

    @Override
    protected String description() {
        return "Bei einem Klick auf ein Schild, kann dieses Bearbeitet werden";
    }

    @Override
    protected Material icon() {
        return Material.OAK_SIGN;
    }

    @Override
    protected Options.Option defaultValue() {
        return editableWhenEmpty;
    }

    @Override
    public SettingCategory category() {
        return SettingCategory.Gameplay;
    }
}
