package eu.mhsl.craftattack.spawn.craftattack.appliances.gameplay.autoShulker;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Material;
import org.bukkit.block.ShulkerBox;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.BlockStateMeta;
import org.jetbrains.annotations.NotNull;

import java.util.HashMap;
import java.util.List;

public class AutoShulker extends Appliance {
    @Override
    public void onEnable() {
        Settings.instance().declareSetting(AutoShulkerSetting.class);
    }

    public boolean tryAutoShulker(Player p, Item item) {
        ItemStack itemStack = item.getItemStack();
        ItemStack offhandStack = p.getInventory().getItemInOffHand();
        if(itemStack.getType().equals(Material.SHULKER_BOX)) return false;
        if(!offhandStack.getType().equals(Material.SHULKER_BOX)) return false;
        BlockStateMeta blockStateMeta = (BlockStateMeta) offhandStack.getItemMeta();
        ShulkerBox shulkerBox = (ShulkerBox) blockStateMeta.getBlockState();

        HashMap<Integer, ItemStack> leftOver = shulkerBox.getInventory().addItem(itemStack);
        if(leftOver.size() > 1)
            throw new IllegalStateException("Multiple ItemStacks cannot be processed by AutoShulker!");
        if(itemStack.equals(leftOver.get(0))) {
            p.sendActionBar(Component.text("Die Shulkerbox ist voll!", NamedTextColor.RED));
            return false;
        }
        if(leftOver.isEmpty()) {
            item.remove();
        }

        blockStateMeta.setBlockState(shulkerBox);
        offhandStack.setItemMeta(blockStateMeta);
        return true;
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new ItemPickupListener());
    }
}
