package eu.mhsl.craftattack.spawn.craftattack.appliances.gameplay.customAdvancements;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.inventory.CraftItemEvent;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.inventory.ItemStack;

class CustomAdvancementsListener extends ApplianceListener<CustomAdvancements> {
    @EventHandler
    public void onEntityDamageEntity(EntityDamageByEntityEvent event) {
        if(!(event.getEntity() instanceof Player damaged)) return;
        if(!(event.getDamager() instanceof Player damager)) return;
        if(!damager.getInventory().getItemInMainHand().getType().equals(Material.AIR)) return;
        if(!damaged.hasPermission("admin")) return;

        this.getAppliance().grantAdvancement(Advancements.searchTrouble, damager.getUniqueId());
    }

    @EventHandler
    public void onCraftItem(CraftItemEvent event) {
        ItemStack result = event.getInventory().getResult();
        if(result == null) return;
        if(!(event.getView().getPlayer() instanceof Player player)) return;

        if(result.getType() == Material.RED_SHULKER_BOX) {
            this.getAppliance().grantAdvancement(Advancements.fleischerchest, player.getUniqueId());
            return;
        }

        if(result.getItemMeta().itemName().equals(Component.text("98fdf0ae-c3ab-4ef7-ae25-efd518d600de"))) {
            this.getAppliance().grantAdvancement(Advancements.craftPixelblock, player.getUniqueId());
        }
    }

    @EventHandler
    public void onChangeWorld(PlayerChangedWorldEvent event) {
        if(!event.getPlayer().getWorld().getName().startsWith("plugins/PixelBlocks/worlds")) return;

        this.getAppliance().grantAdvancement(Advancements.usePixelblock, event.getPlayer().getUniqueId());
    }
}
