package eu.mhsl.craftattack.spawn.craftattack.appliances.gameplay.hotbarRefill;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerItemBreakEvent;
import org.bukkit.event.player.PlayerItemConsumeEvent;
import org.bukkit.inventory.ItemStack;

import java.util.List;

class HotbarRefillListener extends ApplianceListener<HotbarRefill> {
    private HotbarRefillSetting.HotbarReplaceConfig getPlayerSetting(Player player) {
        return Settings.instance().getSetting(
            player,
            Settings.Key.HotbarReplacer,
            HotbarRefillSetting.HotbarReplaceConfig.class
        );
    }

    @EventHandler
    public void blockPlace(BlockPlaceEvent event) {
        ItemStack stackInHand = event.getItemInHand();
        if(stackInHand.getAmount() != 1) return;
        if(stackInHand.getType().getMaxDurability() > 0) return;
        if(stackInHand.getType().getMaxStackSize() > 0) return;

        if(!this.getPlayerSetting(event.getPlayer()).onBlocks()) return;
        this.getAppliance().handleHotbarChange(event.getPlayer(), stackInHand);
    }

    @EventHandler
    public void onPlayerItemBreak(PlayerItemBreakEvent event) {
        if(!this.getPlayerSetting(event.getPlayer()).onTools()) return;

        this.getAppliance().handleHotbarChange(event.getPlayer(), event.getBrokenItem());
    }

    @EventHandler
    public void onPlayerItemConsume(PlayerItemConsumeEvent event) {
        if(List.of(Material.POTION, Material.HONEY_BOTTLE).contains(event.getItem().getType())) return;
        if(!this.getPlayerSetting(event.getPlayer()).onConsumable()) return;

        this.getAppliance().handleHotbarChange(event.getPlayer(), event.getItem());
    }
}
