package eu.mhsl.craftattack.spawn.craftattack.appliances.gameplay.hotbarRefill;

import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.CategorizedSetting;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.SettingCategory;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.datatypes.MultiBoolSetting;
import org.bukkit.Material;

public class HotbarRefillSetting extends MultiBoolSetting<HotbarRefillSetting.HotbarReplaceConfig> implements CategorizedSetting {
    @Override
    public SettingCategory category() {
        return SettingCategory.Gameplay;
    }

    public record HotbarReplaceConfig(
        @DisplayName("Blöcke") boolean onBlocks,
        @DisplayName("Werkzeuge") boolean onTools,
        @DisplayName("Essen") boolean onConsumable
    ) {
    }

    public HotbarRefillSetting() {
        super(Settings.Key.HotbarReplacer);
    }

    @Override
    protected String title() {
        return "Automatische Hotbar";
    }

    @Override
    protected String description() {
        return "Verschiebe Items automatisch von deinem Inventar in die Hotbar, wenn diese verbraucht werden";
    }

    @Override
    protected Material icon() {
        return Material.CHEST;
    }

    @Override
    protected HotbarReplaceConfig defaultValue() {
        return new HotbarReplaceConfig(false, false, false);
    }

    @Override
    public Class<?> dataType() {
        return HotbarReplaceConfig.class;
    }
}
