package eu.mhsl.craftattack.spawn.craftattack.appliances.metaGameplay.playtime;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.core.util.text.DataSizeConverter;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.util.Ticks;
import org.bukkit.OfflinePlayer;
import org.bukkit.Statistic;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.Objects;

public class Playtime extends Appliance {
    public Component getFormattedPlaytime(OfflinePlayer player) {
        int playtimeInTicks = player.getStatistic(Statistic.PLAY_ONE_MINUTE);
        String playtime = DataSizeConverter.formatSecondsToHumanReadable(playtimeInTicks / Ticks.TICKS_PER_SECOND);
        return Component.text()
            .append(Component.text("Der Spieler ", NamedTextColor.GRAY))
            .append(Component.text(Objects.requireNonNull(player.getName())))
            .append(Component.text(" hat eine Spielzeit von ", NamedTextColor.GRAY))
            .append(Component.text(playtime, NamedTextColor.GOLD))
            .build();
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new PlaytimeCommand());
    }
}
