package eu.mhsl.craftattack.spawn.craftattack.appliances.metaGameplay.playtime;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;

class PlaytimeCommand extends ApplianceCommand.PlayerChecked<Playtime> {
    public PlaytimeCommand() {
        super("playtime");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        String playerName = args.length == 1 ? args[0] : this.getPlayer().getName();

        Bukkit.getScheduler().runTaskAsynchronously(Main.instance(), () -> {
            OfflinePlayer player = Bukkit.getOfflinePlayer(playerName);
            if(!player.hasPlayedBefore()) {
                sender.sendMessage(Component.text("Der Spieler existiert nicht!", NamedTextColor.RED));
                return;
            }
            sender.sendMessage(this.getAppliance().getFormattedPlaytime(player));
        });
    }
}