package eu.mhsl.craftattack.spawn.craftattack.appliances.metaGameplay.worldmuseum;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.core.util.entity.DisplayVillager;
import eu.mhsl.craftattack.spawn.core.util.listener.DismissInventoryOpenFromHolder;
import eu.mhsl.craftattack.spawn.core.util.listener.PlayerInteractAtEntityEventListener;
import eu.mhsl.craftattack.spawn.core.util.server.PluginMessage;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.entity.Villager;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class WorldMuseum extends Appliance {
    public DisplayVillager.ConfigBound villager;

    public WorldMuseum() {
        super("worldMuseum");
    }

    @Override
    public void onEnable() {
        this.villager = new DisplayVillager.ConfigBound(
            this.localConfig(),
            villager -> {
                villager.customName(Component.text("Museum der Welten").color(NamedTextColor.GOLD));
                villager.setProfession(Villager.Profession.CARTOGRAPHER);
                villager.setVillagerType(Villager.Type.SNOW);
            }
        );
    }

    public void updateVillagerPosition(Location location) {
        this.villager.updateLocation(location);
    }

    public void handleVillagerInteraction(Player player) {
        Main.logger().info("Sending" + player.getName() + " to WorldMuseum");
        PluginMessage.connect(player, this.localConfig().getString("connect-server-name"));
    }

    @Override
    @NotNull
    protected List<ApplianceCommand<?>> commands() {
        return List.of(new MoveWorldMuseumVillagerCommand());
    }

    @Override
    @NotNull
    protected List<Listener> listeners() {
        return List.of(
            new PlayerInteractAtEntityEventListener(this.villager.getUniqueId(), playerInteractAtEntityEvent -> this.handleVillagerInteraction(playerInteractAtEntityEvent.getPlayer())),
            new DismissInventoryOpenFromHolder(this.villager.getUniqueId())
        );
    }
}
