package eu.mhsl.craftattack.spawn.craftattack.appliances.tooling.spawnpoint;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.Locale;

public class Spawnpoint extends Appliance {
    private static final String namespace = Spawnpoint.class.getSimpleName().toLowerCase(Locale.ROOT);
    public static NamespacedKey alreadySpawned = new NamespacedKey(namespace, "alreadySpawned".toLowerCase());
    private static final String position = "position";

    private Location spawnPoint;

    public Spawnpoint() {
        super("spawnpoint");
        this.spawnPoint = this.localConfig().getLocation(position, new Location(Bukkit.getWorlds().getFirst(), 0, 100, 0));
    }

    public void setSpawnpoint(Location location) {
        this.localConfig().set("position", location);
        this.spawnPoint = location;
    }

    public void handlePlayerLogin(Player player) {
        PersistentDataContainer dataContainer = player.getPersistentDataContainer();
        if(dataContainer.has(alreadySpawned)) return;
        player.teleportAsync(this.spawnPoint);
        dataContainer.set(alreadySpawned, PersistentDataType.BOOLEAN, true);
    }

    public Location getSpawnPoint() {
        return this.spawnPoint;
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new SetSpawnpointCommand());
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new SpawnAtSpawnpointListener());
    }
}
