package eu.mhsl.craftattack.spawn.craftattack.appliances.tooling.whitelist;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.core.util.text.DisconnectInfo;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;
import org.bukkit.event.player.PlayerLoginEvent;

class PlayerJoinListener extends ApplianceListener<Whitelist> {
    @EventHandler
    public void preLoginEvent(AsyncPlayerPreLoginEvent event) {
        try {
            this.getAppliance().integrityCheck(event.getUniqueId(), event.getName());
        } catch(DisconnectInfo.Throwable e) {
            event.disallow(
                AsyncPlayerPreLoginEvent.Result.KICK_WHITELIST,
                e.getDisconnectScreen().getComponent()
            );
        }
    }

    @EventHandler
    public void joinEvent(PlayerLoginEvent event) {
        try {
            this.getAppliance().lateIntegrityCheck(event.getPlayer());
        } catch(DisconnectInfo.Throwable e) {
            event.disallow(
                PlayerLoginEvent.Result.KICK_WHITELIST,
                e.getDisconnectScreen().getComponent()
            );
        }
    }
}
