package eu.mhsl.craftattack.spawn.varo.api.repositories;

import com.google.common.reflect.TypeToken;
import eu.mhsl.craftattack.spawn.core.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.common.api.VaroApi;

import java.util.List;
import java.util.UUID;

public class TeamRepository extends HttpRepository {
    public TeamRepository() {
        super(VaroApi.getBaseUri(), new RequestModifier(null, VaroApi::authorizationHeader));
    }

    public record Team(
        String name,
        String color,
        Object lastJoined,
        Object strikeWeight,
        List<User> users
    ) {
        public record User(
            UUID uuid,
            boolean dead
        ) {}
    }

    public ReqResp<List<Team>> getTeams() {
        var resp = this.get("team", Object.class);
        return resp
            .convertToTypeToken(new TypeToken<List<Team>>() {}.getType())
            .cast();
    }
}
