package eu.mhsl.craftattack.spawn.varo.api.repositories;

import eu.mhsl.craftattack.spawn.core.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.core.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.common.api.VaroApi;
import org.jetbrains.annotations.Nullable;

import java.util.UUID;

public class VaroPlayerRepository extends HttpRepository {
    public VaroPlayerRepository() {
        super(VaroApi.getBaseUri(), new RequestModifier(null, VaroApi::authorizationHeader));
    }

    public record VaroDeath(UUID user, @Nullable UUID killer, String message) {}
    public ReqResp<Void> registerDeath(VaroDeath death) {
        return this.post("player/death", death, Void.class);
    }
}
