package eu.mhsl.craftattack.spawn.varo.appliances.internal.teamTasks;

import eu.mhsl.craftattack.spawn.core.Main;
import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams.Teams;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.stream.Collectors;

public class TeamTasksCommand extends ApplianceCommand<TeamTasks> {
    public TeamTasksCommand() {
        super("teamTasks");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(args.length < 1) throw new Error("Please specify Teamname");
        var team = Main.instance().getAppliance(Teams.class).findTeamByName(args[0]);
        if(team == null) throw new Error("Team not found!");
        var tasks = this.getAppliance().getRunningTeamTasks(team);
        if(tasks.isEmpty()) {
            sender.sendMessage("No Tasks found!");
        } else {
            sender.sendMessage(
                tasks.entrySet()
                    .stream()
                    .map(entry -> String.format("%s: %s", entry.getKey().name(), entry.getValue().getClass().getSimpleName()))
                    .collect(Collectors.joining("\n"))
            );
        }
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        var teams = Main.instance().getAppliance(Teams.class).getAllTeams();
        return teams.stream().map(team -> team.name).toList();
    }
}
