package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.forbiddenItems;

import eu.mhsl.craftattack.spawn.core.appliance.Appliance;
import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Villager;
import org.bukkit.event.Listener;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.Set;

public class ForbiddenItems extends Appliance {
    public ForbiddenGroup<Material> forbiddenMaterials = new ForbiddenGroup<>(Set.of(
        (material) -> material.name().startsWith("NETHERITE"),
        (material) -> material.equals(Material.TOTEM_OF_UNDYING),
        (material) -> material.equals(Material.END_CRYSTAL),
        (material) -> material.equals(Material.MACE),
        (material) -> material.equals(Material.ENCHANTED_GOLDEN_APPLE)
    ));

    public ForbiddenGroup<Entity> forbiddenEntities = new ForbiddenGroup<>(Set.of(
        (entity) -> {
            if(!(entity instanceof Villager villager)) return false;
            return List.of(
                Villager.Profession.LIBRARIAN,
                Villager.Profession.ARMORER
            ).contains(villager.getProfession());
        }
    ));

    public ForbiddenGroup<PotionEffect> forbiddenPotions = new ForbiddenGroup<>(Set.of(
        (potion) -> !potion.getType().equals(PotionEffectType.INSTANT_HEALTH) && potion.getAmplifier() >= 1     // Amplifier starts at 0
    ));

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(
            new ForbiddenMaterialListener(),
            new ForbiddenEntityListener(),
            new ForbiddenPotionsListener()
        );
    }
}
