package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.forbiddenItems;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntityPickupItemEvent;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;

import java.util.List;
import java.util.Objects;

class ForbiddenMaterialListener extends ApplianceListener<ForbiddenItems> {
    @EventHandler
    public void onPickup(EntityPickupItemEvent event) {
        this.testAndCancel(event, event.getItem().getItemStack().getType(), event.getEntity());
    }

    @EventHandler
    public void onInventoryInteraction(InventoryClickEvent event) {
        if(event.getCurrentItem() == null) return;
        if(List.of(ClickType.DROP, ClickType.CONTROL_DROP).contains(event.getClick())) return;
        boolean wasCancelled = this.testAndCancel(event, event.getCurrentItem().getType(), event.getWhoClicked());
        if(wasCancelled) Objects.requireNonNull(event.getClickedInventory()).remove(event.getCurrentItem());
    }

    private boolean testAndCancel(Cancellable event, Material material, Entity entity) {
        if(!this.getAppliance().forbiddenMaterials.isForbidden(material)) return false;
        event.setCancelled(true);

        if(entity instanceof Player p) {
            Component itemName = material.getItemTranslationKey() != null
                ? Component.translatable(material.getItemTranslationKey())
                : Component.text(material.name());

            p.sendActionBar(
                Component.text()
                    .append(itemName)
                    .append(Component.text(" ist ein verbotener Gegenstand!"))
            );
        }

        return true;
    }
}
