package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.forbiddenItems;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import net.kyori.adventure.text.Component;
import org.bukkit.entity.Player;
import org.bukkit.event.Cancellable;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.LingeringPotionSplashEvent;
import org.bukkit.event.entity.PotionSplashEvent;
import org.bukkit.event.player.PlayerItemConsumeEvent;
import org.bukkit.inventory.meta.PotionMeta;
import org.bukkit.potion.PotionEffect;

import javax.annotation.Nullable;
import java.util.Collection;

class ForbiddenPotionsListener extends ApplianceListener<ForbiddenItems> {
    @EventHandler
    public void onPotionSplash(PotionSplashEvent event) {
        Collection<PotionEffect> effects = event.getPotion().getEffects();

        this.testAndCancel(event, effects, null);
    }

    @EventHandler
    public void onPotionConsume(PlayerItemConsumeEvent event) {
        if(!(event.getItem().getItemMeta() instanceof PotionMeta meta)) return;
        if(meta.getBasePotionType() == null) return;
        Collection<PotionEffect> effects = meta.getBasePotionType().getPotionEffects();

        this.testAndCancel(event, effects, event.getPlayer());
    }

    @EventHandler
    public void onLingeringPotionSplash(LingeringPotionSplashEvent event) {
        if(event.getAreaEffectCloud().getBasePotionType() == null) return;
        Collection<PotionEffect> effects = event.getAreaEffectCloud().getBasePotionType().getPotionEffects();

        this.testAndCancel(event, effects, null);
    }

    private void testAndCancel(Cancellable event, Collection<PotionEffect> effects, @Nullable Player player) {
        if(effects.stream().noneMatch(potionEffect -> this.getAppliance().forbiddenPotions.isForbidden(potionEffect))) return;

        event.setCancelled(true);

        if(player == null) return;

        player.sendActionBar(
            Component.text()
                .append(Component.text("Das ist ein verbotener Trank!"))
        );
    }
}
