package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.joinProtection;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.player.*;

public class JoinProtectionListener extends ApplianceListener<JoinProtection> {
    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        this.getAppliance().addProtection(event.getPlayer());
    }

    @EventHandler
    public void onDamage(EntityDamageEvent event) {
        if(!(event.getEntity() instanceof Player player)) return;
        if(event.getCause().equals(EntityDamageEvent.DamageCause.FALL)) return;
        this.getAppliance().cancelEvent(player, event);
    }

    @EventHandler
    public void onConsume(PlayerItemConsumeEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onMove(PlayerMoveEvent event) {
        if(!event.hasChangedPosition()) return;
        JoinProtection.Options option = this.getAppliance().getOptions(event.getPlayer());
        if(option == null) return;
        if(!option.wasOnGround) {
            option.wasOnGround = ((LivingEntity) event.getPlayer()).isOnGround();
            return;
        }

        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onInteract(PlayerInteractEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onBlockBreak(BlockBreakEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }

    @EventHandler
    public void onFlightChange(PlayerToggleFlightEvent event) {
        this.getAppliance().cancelEvent(event.getPlayer(), event);
    }
}
