package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.shrinkingBorder;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.common.appliances.metaGameplay.settings.Settings;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.WorldBorder;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.PlayerMoveEvent;

public class ShrinkingBorderListener extends ApplianceListener<ShrinkingBorder> {
    @EventHandler
    public void onPlayerMove(PlayerMoveEvent event) {
        if(!event.hasChangedPosition()) return;
        if(event.getTo().getWorld().getEnvironment().equals(World.Environment.THE_END)) return;
        if(this.isSave(event.getTo())) return;
        int remainingDays = this.daysUntilBorder(event.getTo());

        int maxDaysShown = Settings.instance().getSetting(event.getPlayer(), Settings.Key.BorderWarning, Integer.class);

        if(remainingDays > maxDaysShown) return;

        String actionBarText;
        if(remainingDays <= 0) {
            actionBarText = "Du befindest dich in der Worldborder!";
        } else if(remainingDays == 1) {
            actionBarText = "Morgen ist die Worldborder hier! Ausloggen = ☠";
        } else {
            actionBarText = String.format("In %d Tagen ist die Worldborder hier!", remainingDays);
        }

        event.getPlayer().sendActionBar(Component.text(
            actionBarText,
            TextColor.color(255, 0, 0)
        ));
    }

    private int daysUntilBorder(Location playerLocation) {
        WorldBorder worldBorder = playerLocation.getWorld().getWorldBorder();
        Location relativeLocation = playerLocation.clone().subtract(worldBorder.getCenter());
        double playerBorderDistanceX = worldBorder.getSize()/2 - Math.abs(relativeLocation.getX());
        double playerBorderDistanceZ = worldBorder.getSize()/2 - Math.abs(relativeLocation.getZ());
        int xSteps = (int) Math.ceil(playerBorderDistanceX / this.getAppliance().getOption(ShrinkingBorderCommand.Argument.SHRINK_PER_DAY));
        int zSteps = (int) Math.ceil(playerBorderDistanceZ / this.getAppliance().getOption(ShrinkingBorderCommand.Argument.SHRINK_PER_DAY));
        return Math.min(xSteps, zSteps);
    }

    private boolean isSave(Location playerLocation) {
        WorldBorder worldBorder = playerLocation.getWorld().getWorldBorder();
        Location relativeLocation = playerLocation.clone().subtract(worldBorder.getCenter());
        if(Math.abs(relativeLocation.getX()) > this.getAppliance().getOption(ShrinkingBorderCommand.Argument.MINIMUM_SIZE)) return false;
        if(Math.abs(relativeLocation.getZ()) > this.getAppliance().getOption(ShrinkingBorderCommand.Argument.MINIMUM_SIZE)) return false;
        return true;
    }
}
