package eu.mhsl.craftattack.spawn.varo.appliances.metaGameplay.teams;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;

import java.util.stream.Collectors;

public class TeamListCommand extends ApplianceCommand<Teams> {
    public TeamListCommand() {
        super("teamList");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        String teams = this.getAppliance().getAllTeams().stream()
            .map(team -> {
                String members = team.members.stream()
                    .map(member -> String.format("%s(%s)", member.player.getName(), member.isDead ? "☠" : "♥"))
                    .collect(Collectors.joining(", "));
                return String.format("%s: %s", team.name, members);
            })
            .collect(Collectors.joining("\n"));

        sender.sendMessage(teams);
    }
}
