package eu.mhsl.craftattack.spawn.varo.appliances.tooling.spawnpoint;

import eu.mhsl.craftattack.spawn.core.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;

class SetSpawnpointCommand extends ApplianceCommand.PlayerChecked<Spawnpoint> {
    public SetSpawnpointCommand() {
        super("setSpawnpoint");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(args.length < 1) throw new Error("Specify playername for the Spawnpoint");
        var location = this.getPlayer().getLocation()
            .toBlockLocation()
            .add(0.5, 0.5, 0.5);
        location.setYaw(0);
        location.setPitch(0);

        this.getAppliance().setSpawnpoint(location, args[0]);
        sender.sendMessage(Component.text("Spawnpoint updated!", NamedTextColor.GREEN));
    }
}
